<?php

declare(strict_types = 1);

namespace Drupal\config_revision;

use Drupal\config_revision\Controller\RevisionOverviewController;
use Drupal\config_revision\Form\RevisionRevertForm;
use Drupal\Core\Entity\EntityTypeInterface;
use Drupal\Core\Entity\Routing\RevisionHtmlRouteProvider;

/**
 * Revision route provider.
 */
class RevisionRouteProvider extends RevisionHtmlRouteProvider {

  /**
   * {@inheritdoc}
   */
  protected function getRevisionHistoryRoute(EntityTypeInterface $entity_type) {
    $route = parent::getRevisionHistoryRoute($entity_type);
    $route->setDefault('_controller', RevisionOverviewController::class . '::revisionOverviewController');
    $route->setRequirement('_permission', 'administer config_revision');
    return $route;
  }

  /**
   * {@inheritdoc}
   */
  protected function getRevisionViewRoute(EntityTypeInterface $entity_type) {
    $route = parent::getRevisionViewRoute($entity_type);
    $route->setOption('_admin_route', 'TRUE');
    return $route;
  }

  /**
   * {@inheritdoc}
   */
  protected function getRevisionRevertRoute(EntityTypeInterface $entity_type) {
    $route = parent::getRevisionRevertRoute($entity_type);
    $route->setDefault('_form', RevisionRevertForm::class);
    $route->setOption('_admin_route', 'TRUE');
    return $route;
  }

}
